Index: /pjproject/branches/symbian/pjlib-util/src/pjlib-util/errno.c
===================================================================
--- /pjproject/branches/symbian/pjlib-util/src/pjlib-util/errno.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib-util/src/pjlib-util/errno.c	(revision 789)
@@ -17,5 +17,5 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <pjlib-util/errno.h>
+#include <pjlib-util.h>
 #include <pj/string.h>
 
Index: /pjproject/branches/symbian/pjlib-util/src/pjlib-util/string.c
===================================================================
--- /pjproject/branches/symbian/pjlib-util/src/pjlib-util/string.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib-util/src/pjlib-util/string.c	(revision 789)
@@ -32,5 +32,5 @@
 	return *src_str;
 
-    dst = dst_str.ptr = pj_pool_alloc(pool, src_str->slen);
+    dst = dst_str.ptr = (char*) pj_pool_alloc(pool, src_str->slen);
 
     while (src != end) {
Index: /pjproject/branches/symbian/pjlib-util/src/pjlib-util/stun.c
===================================================================
--- /pjproject/branches/symbian/pjlib-util/src/pjlib-util/stun.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib-util/src/pjlib-util/stun.c	(revision 789)
@@ -36,5 +36,5 @@
 
 
-    hdr = pj_pool_calloc(pool, 1, sizeof(pj_stun_msg_hdr));
+    hdr = (pj_stun_msg_hdr*) pj_pool_calloc(pool, 1, sizeof(pj_stun_msg_hdr));
     if (!hdr)
 	return PJ_ENOMEM;
Index: /pjproject/branches/symbian/pjlib-util/src/pjlib-util/stun_client.c
===================================================================
--- /pjproject/branches/symbian/pjlib-util/src/pjlib-util/stun_client.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib-util/src/pjlib-util/stun_client.c	(revision 789)
@@ -42,5 +42,5 @@
     int i, j, send_cnt = 0;
     pj_pool_t *pool;
-    struct {
+    struct stun_rec {
 	struct {
 	    pj_uint32_t	mapped_addr;
@@ -62,5 +62,5 @@
 
     /* Allocate client records */
-    rec = pj_pool_calloc(pool, sock_cnt, sizeof(*rec));
+    rec = (struct stun_rec*) pj_pool_calloc(pool, sock_cnt, sizeof(*rec));
     if (!rec) {
 	status = PJ_ENOMEM;
@@ -98,5 +98,5 @@
 	for (i=0; i<sock_cnt && status==PJ_SUCCESS; ++i) {
 	    for (j=0; j<2 && status==PJ_SUCCESS; ++j) {
-		pj_stun_msg_hdr *msg_hdr = out_msg;
+		pj_stun_msg_hdr *msg_hdr = (pj_stun_msg_hdr*) out_msg;
                 pj_ssize_t sent_len;
 
@@ -195,5 +195,5 @@
 		}
 
-		attr = (void*)pj_stun_msg_find_attr(&msg, PJ_STUN_ATTR_MAPPED_ADDR);
+		attr = (pj_stun_mapped_addr_attr *)pj_stun_msg_find_attr(&msg, PJ_STUN_ATTR_MAPPED_ADDR);
 		if (!attr) {
 		    status = PJLIB_UTIL_ESTUNNOMAP;
Index: /pjproject/branches/symbian/pjlib-util/src/pjlib-util/xml.c
===================================================================
--- /pjproject/branches/symbian/pjlib-util/src/pjlib-util/xml.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib-util/src/pjlib-util/xml.c	(revision 789)
@@ -38,5 +38,5 @@
     pj_xml_node *node;
 
-    node = pj_pool_zalloc(pool, sizeof(pj_xml_node));
+    node = (pj_xml_node*) pj_pool_zalloc(pool, sizeof(pj_xml_node));
     pj_list_init( &node->attr_head );
     pj_list_init( &node->node_head );
@@ -47,5 +47,5 @@
 static pj_xml_attr *alloc_attr( pj_pool_t *pool )
 {
-    return pj_pool_zalloc(pool, sizeof(pj_xml_attr));
+    return (pj_xml_attr*) pj_pool_zalloc(pool, sizeof(pj_xml_attr));
 }
 
@@ -394,5 +394,6 @@
 				  pj_bool_t (*match)(pj_xml_node *, const void*))
 {
-    pj_xml_node *head = (void*)&parent->node_head, *node = head->next;
+    pj_xml_node *head = (pj_xml_node *) &parent->node_head, 
+	        *node = head->next;
 
     while (node != (void*)head) {
Index: /pjproject/branches/symbian/pjlib/include/pj/compat/os_symbian.h
===================================================================
--- /pjproject/branches/symbian/pjlib/include/pj/compat/os_symbian.h	(revision 788)
+++ /pjproject/branches/symbian/pjlib/include/pj/compat/os_symbian.h	(revision 789)
@@ -103,5 +103,11 @@
  */
 
-#define NULL 0
+#ifndef NULL
+#   define NULL 0
+#endif
+
+
+/* Doesn't seem to allow more than this */
+#define PJ_IOQUEUE_MAX_HANDLES	    8
 
 /*
@@ -109,5 +115,5 @@
  */
 #define PJ_HAS_FLOATING_POINT	    1
-#define PJ_HAS_MALLOC               1
+#define PJ_HAS_MALLOC               0
 #define PJ_HAS_SEMAPHORE	    1
 #define PJ_HAS_EVENT_OBJ	    0
Index: /pjproject/branches/symbian/pjlib/include/pj/compat/socket.h
===================================================================
--- /pjproject/branches/symbian/pjlib/include/pj/compat/socket.h	(revision 788)
+++ /pjproject/branches/symbian/pjlib/include/pj/compat/socket.h	(revision 789)
@@ -82,4 +82,8 @@
 #  define OSERR_EINPROGRESS    WSAEINPROGRESS
 #  define OSERR_ECONNRESET     WSAECONNRESET
+#elif defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
+#  define OSERR_EWOULDBLOCK    -1
+#  define OSERR_EINPROGRESS    -1
+#  define OSERR_ECONNRESET     -1
 #else
 #  define OSERR_EWOULDBLOCK    EWOULDBLOCK
Index: /pjproject/branches/symbian/pjlib/include/pj/list_i.h
===================================================================
--- /pjproject/branches/symbian/pjlib/include/pj/list_i.h	(revision 788)
+++ /pjproject/branches/symbian/pjlib/include/pj/list_i.h	(revision 789)
@@ -125,5 +125,5 @@
     while (node != list) {
 	++count;
-	node = node->next;
+	node = (pj_list*)node->next;
     }
 
Index: /pjproject/branches/symbian/pjlib/src/pj/array.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/array.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/array.c	(revision 789)
@@ -56,5 +56,5 @@
 {
     unsigned i;
-    const char *char_array = array;
+    const char *char_array = (const char*) array;
     for (i=0; i<count; ++i) {
 	if ( (*matching)(char_array) == PJ_SUCCESS) {
Index: /pjproject/branches/symbian/pjlib/src/pj/errno.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/errno.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/errno.c	(revision 789)
@@ -24,6 +24,8 @@
  * in separate file.
  */
-extern int platform_strerror( pj_os_err_type code, 
-                              char *buf, pj_size_t bufsize );
+PJ_BEGIN_DECL
+PJ_DECL(int) platform_strerror(pj_os_err_type code, 
+                               char *buf, pj_size_t bufsize );
+PJ_END_DECL
 
 #define PJLIB_MAX_ERR_MSG_HANDLER   8
Index: /pjproject/branches/symbian/pjlib/src/pj/fifobuf.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/fifobuf.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/fifobuf.c	(revision 789)
@@ -35,5 +35,5 @@
 	       fifobuf, buffer, size));
 
-    fifobuf->first = buffer;
+    fifobuf->first = (char*) buffer;
     fifobuf->last = fifobuf->first + size;
     fifobuf->ubegin = fifobuf->uend = fifobuf->first;
@@ -119,5 +119,5 @@
 pj_fifobuf_unalloc (pj_fifobuf_t *fifobuf, void *buf)
 {
-    char *ptr = buf;
+    char *ptr = (char*) buf;
     char *endptr;
     unsigned sz;
@@ -150,5 +150,5 @@
 pj_fifobuf_free (pj_fifobuf_t *fifobuf, void *buf)
 {
-    char *ptr = buf;
+    char *ptr = (char*) buf;
     char *end;
     unsigned sz;
Index: /pjproject/branches/symbian/pjlib/src/pj/guid.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/guid.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/guid.c	(revision 789)
@@ -22,5 +22,5 @@
 PJ_DEF(void) pj_create_unique_string(pj_pool_t *pool, pj_str_t *str)
 {
-    str->ptr = pj_pool_alloc(pool, PJ_GUID_STRING_LENGTH);
+    str->ptr = (char*) pj_pool_alloc(pool, PJ_GUID_STRING_LENGTH);
     pj_generate_unique_string(str);
 }
Index: /pjproject/branches/symbian/pjlib/src/pj/hash.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/hash.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/hash.c	(revision 789)
@@ -56,10 +56,10 @@
 
     if (keylen==PJ_HASH_KEY_STRING) {
-	const unsigned char *p = key;
+	const unsigned char *p = (const unsigned char*) key;
 	for ( ; *p; ++p ) {
 	    hash = (hash * PJ_HASH_MULTIPLIER) + *p;
 	}
     } else {
-	const unsigned char *p = key,
+	const unsigned char *p = (const unsigned char*) key,
 			    *end = p + keylen;
 	for ( ; p!=end; ++p) {
@@ -93,5 +93,5 @@
     PJ_ASSERT_RETURN(sizeof(pj_hash_entry)==PJ_HASH_ENTRY_SIZE, NULL);
 
-    h = pj_pool_alloc(pool, sizeof(pj_hash_table_t));
+    h = (pj_hash_table_t*) pj_pool_alloc(pool, sizeof(pj_hash_table_t));
     h->count = 0;
 
@@ -109,5 +109,5 @@
     
     h->rows = table_size;
-    h->table = pj_pool_calloc(pool, table_size+1, sizeof(pj_hash_entry*));
+    h->table = (pj_hash_entry**) pj_pool_calloc(pool, table_size+1, sizeof(pj_hash_entry*));
     return h;
 }
@@ -129,5 +129,5 @@
 	hash=0;
 	if (keylen==PJ_HASH_KEY_STRING) {
-	    const unsigned char *p = key;
+	    const unsigned char *p = (const unsigned char*)key;
 	    for ( ; *p; ++p ) {
 		hash = hash * PJ_HASH_MULTIPLIER + *p;
@@ -135,5 +135,5 @@
 	    keylen = p - (const unsigned char*)key;
 	} else {
-	    const unsigned char *p = key,
+	    const unsigned char *p = (const unsigned char*) key,
 				*end = p + keylen;
 	    for ( ; p!=end; ++p) {
@@ -166,10 +166,10 @@
      */
     if (entry_buf) {
-	entry = entry_buf;
+	entry = (pj_hash_entry*) entry_buf;
     } else {
 	/* Pool must be specified! */
 	PJ_ASSERT_RETURN(pool != NULL, NULL);
 
-	entry = pj_pool_alloc(pool, sizeof(pj_hash_entry));
+	entry = (pj_hash_entry*) pj_pool_alloc(pool, sizeof(pj_hash_entry));
 	PJ_LOG(6, ("hashtbl", 
 		   "%p: New p_entry %p created, pool used=%u, cap=%u", 
Index: /pjproject/branches/symbian/pjlib/src/pj/ioqueue_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/ioqueue_symbian.cpp	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/ioqueue_symbian.cpp	(revision 789)
@@ -45,13 +45,9 @@
 {
 public:
-    CIoqueueCallback(pj_ioqueue_t *ioqueue,
-		     pj_ioqueue_key_t *key, pj_sock_t sock, 
-		     const pj_ioqueue_callback *cb, void *user_data)
-    : CActive(CActive::EPriorityStandard),
-	  ioqueue_(ioqueue), key_(key), sock_((CPjSocket*)sock), cb_(cb), 
-	  user_data_(user_data), aBufferPtr_(NULL, 0), type_(TYPE_NONE)
-    {
-	CActiveScheduler::Add(this);
-    }
+    static CIoqueueCallback* NewL(pj_ioqueue_t *ioqueue,
+				  pj_ioqueue_key_t *key, 
+				  pj_sock_t sock, 
+				  const pj_ioqueue_callback *cb, 
+				  void *user_data);
 
     //
@@ -60,22 +56,5 @@
     pj_status_t StartRead(pj_ioqueue_op_key_t *op_key, 
 			  void *buf, pj_ssize_t *size, unsigned flags,
-			  pj_sockaddr_t *addr, int *addrlen)
-    {
-	PJ_ASSERT_RETURN(IsActive()==false, PJ_EBUSY);
-	PJ_ASSERT_RETURN(pending_data_.common_.op_key_==NULL, PJ_EBUSY);
-
-	pending_data_.read_.op_key_ = op_key;
-	pending_data_.read_.addr_ = addr;
-	pending_data_.read_.addrlen_ = addrlen;
-
-	aBufferPtr_.Set((TUint8*)buf, 0, (TInt)*size);
-
-	type_ = TYPE_READ;
-	SetActive();
-	sock_->Socket().RecvFrom(aBufferPtr_, aAddress_, flags, iStatus);
-
-	return PJ_EPENDING;
-    }
-
+			  pj_sockaddr_t *addr, int *addrlen);
 
     //
@@ -86,142 +65,21 @@
 			    pj_sockaddr_t *local,
 			    pj_sockaddr_t *remote,
-			    int *addrlen )
-    {
-	PJ_ASSERT_RETURN(IsActive()==false, PJ_EBUSY);
-	PJ_ASSERT_RETURN(pending_data_.common_.op_key_==NULL, PJ_EBUSY);
-
-	pending_data_.accept_.op_key_ = op_key;
-	pending_data_.accept_.new_sock_ = new_sock;
-	pending_data_.accept_.local_ = local;
-	pending_data_.accept_.remote_ = remote;
-	pending_data_.accept_.addrlen_ = addrlen;
-
-	// Create blank socket
-	blank_sock_.Open(PjSymbianOS::Instance()->SocketServ());
-
-	type_ = TYPE_ACCEPT;
-	SetActive();
-	sock_->Socket().Accept(blank_sock_, iStatus);
-
-	return PJ_EPENDING;
-    }
-
+			    int *addrlen );
 
     //
     // Completion callback.
     //
-    void RunL()
-    {
-	Type cur_type = type_;
-
-	type_ = TYPE_NONE;
-
-	if (cur_type == TYPE_READ) {
-	    //
-	    // Completion of asynchronous RecvFrom()
-	    //
-
-	    /* Clear op_key (save it to temp variable first!) */
-	    pj_ioqueue_op_key_t	*op_key = pending_data_.read_.op_key_;
-	    pending_data_.read_.op_key_ = NULL;
-
-	    // Handle failure condition
-	    if (iStatus != KErrNone) {
-		cb_->on_read_complete(key_, op_key, -PJ_RETURN_OS_ERROR(iStatus.Int()));
-		return;
-	    }
-
-	    if (pending_data_.read_.addr_) {
-		PjSymbianOS::Addr2pj(aAddress_, 
-				     *(pj_sockaddr_in*)pending_data_.read_.addr_);
-		pending_data_.read_.addr_ = NULL;
-	    }
-	    if (pending_data_.read_.addrlen_) {
-		*pending_data_.read_.addrlen_ = sizeof(pj_sockaddr_in);
-		pending_data_.read_.addrlen_ = NULL;
-	    }
-
-	    /* Call callback */
-	    cb_->on_read_complete(key_, op_key, aBufferPtr_.Length());
-
-	} else if (cur_type == TYPE_ACCEPT) {
-	    //
-	    // Completion of asynchronous Accept()
-	    //
-	    
-	    /* Clear op_key (save it to temp variable first!) */
-	    pj_ioqueue_op_key_t	*op_key = pending_data_.read_.op_key_;
-	    pending_data_.read_.op_key_ = NULL;
-
-	    // Handle failure condition
-	    if (iStatus != KErrNone) {
-		if (pending_data_.accept_.new_sock_)
-		    *pending_data_.accept_.new_sock_ = PJ_INVALID_SOCKET;
-
-		cb_->on_accept_complete(key_, op_key, PJ_INVALID_SOCKET,
-					-PJ_RETURN_OS_ERROR(iStatus.Int()));
-		return;
-	    }
-
-	    CPjSocket *pjNewSock = new CPjSocket(blank_sock_);
-
-	    if (pending_data_.accept_.new_sock_) {
-		*pending_data_.accept_.new_sock_ = (pj_sock_t)pjNewSock;
-		pending_data_.accept_.new_sock_ = NULL;
-	    }
-
-	    if (pending_data_.accept_.local_) {
-		TInetAddr aAddr;
-		blank_sock_.LocalName(aAddr);
-		PjSymbianOS::Addr2pj(aAddr, *(pj_sockaddr_in*)pending_data_.accept_.local_);
-		pending_data_.accept_.local_ = NULL;
-	    }
-
-	    if (pending_data_.accept_.remote_) {
-		TInetAddr aAddr;
-		blank_sock_.RemoteName(aAddr);
-		PjSymbianOS::Addr2pj(aAddr, *(pj_sockaddr_in*)pending_data_.accept_.remote_);
-		pending_data_.accept_.remote_ = NULL;
-	    }
-
-	    if (pending_data_.accept_.addrlen_) {
-		*pending_data_.accept_.addrlen_ = sizeof(pj_sockaddr_in);
-		pending_data_.accept_.addrlen_ = NULL;
-	    }
-
-	    // Call callback.
-	    cb_->on_accept_complete(key_, op_key, (pj_sock_t)pjNewSock, PJ_SUCCESS);
-	}
-
-	ioqueue_->eventCount++;
-    }
+    void RunL();
 
     //
     // CActive's DoCancel()
     //
-    void DoCancel()
-    {
-	if (type_ == TYPE_READ)
-	    sock_->Socket().CancelRecv();
-	else if (type_ == TYPE_ACCEPT)
-	    sock_->Socket().CancelAccept();
-
-	type_ = TYPE_NONE;
-    }
+    void DoCancel();
 
     //
     // Cancel operation and call callback.
     //
-    void CancelOperation(pj_ioqueue_op_key_t *op_key, pj_ssize_t bytes_status)
-    {
-	Type cur_type = type_;
-
-	Cancel();
-
-	if (cur_type == TYPE_READ)
-	    cb_->on_read_complete(key_, op_key, bytes_status);
-	else if (cur_type == TYPE_ACCEPT)
-	    ;
-    }
+    void CancelOperation(pj_ioqueue_op_key_t *op_key, 
+			 pj_ssize_t bytes_status);
 
     //
@@ -293,9 +151,236 @@
     union Pending_Data		 pending_data_;
     RSocket			blank_sock_;
+
+    CIoqueueCallback(pj_ioqueue_t *ioqueue,
+		     pj_ioqueue_key_t *key, pj_sock_t sock, 
+		     const pj_ioqueue_callback *cb, void *user_data)
+    : CActive(CActive::EPriorityStandard),
+	  ioqueue_(ioqueue), key_(key), sock_((CPjSocket*)sock), cb_(cb), 
+	  user_data_(user_data), aBufferPtr_(NULL, 0), type_(TYPE_NONE)
+    {
+    }
+
+
+    void ConstructL()
+    {
+	CActiveScheduler::Add(this);
+    }
 };
 
 
-
-
+CIoqueueCallback* CIoqueueCallback::NewL(pj_ioqueue_t *ioqueue,
+					 pj_ioqueue_key_t *key, 
+					 pj_sock_t sock, 
+					 const pj_ioqueue_callback *cb, 
+					 void *user_data)
+{
+    CIoqueueCallback *self = new CIoqueueCallback(ioqueue, key, sock, 
+						  cb, user_data);
+    CleanupStack::PushL(self);
+    self->ConstructL();
+    CleanupStack::Pop(self);
+
+    return self;
+}
+
+
+//
+// Start asynchronous recv() operation
+//
+pj_status_t CIoqueueCallback::StartRead(pj_ioqueue_op_key_t *op_key, 
+					void *buf, pj_ssize_t *size, 
+					unsigned flags,
+					pj_sockaddr_t *addr, int *addrlen)
+{
+    PJ_ASSERT_RETURN(IsActive()==false, PJ_EBUSY);
+    PJ_ASSERT_RETURN(pending_data_.common_.op_key_==NULL, PJ_EBUSY);
+
+    flags &= ~PJ_IOQUEUE_ALWAYS_ASYNC;
+
+    pending_data_.read_.op_key_ = op_key;
+    pending_data_.read_.addr_ = addr;
+    pending_data_.read_.addrlen_ = addrlen;
+
+    aBufferPtr_.Set((TUint8*)buf, 0, (TInt)*size);
+
+    type_ = TYPE_READ;
+    if (addr && addrlen) {
+	sock_->Socket().RecvFrom(aBufferPtr_, aAddress_, flags, iStatus);
+    } else {
+	aAddress_.SetAddress(0);
+	aAddress_.SetPort(0);
+	sock_->Socket().Recv(aBufferPtr_, flags, iStatus);
+    }
+
+    if (iStatus==KRequestPending) {
+	SetActive();
+	return PJ_EPENDING;
+    } else {
+	return PJ_RETURN_OS_ERROR(iStatus.Int());
+    }
+}
+
+
+//
+// Start asynchronous accept() operation.
+//
+pj_status_t CIoqueueCallback::StartAccept(pj_ioqueue_op_key_t *op_key,
+					  pj_sock_t *new_sock,
+					  pj_sockaddr_t *local,
+					  pj_sockaddr_t *remote,
+					  int *addrlen )
+{
+    PJ_ASSERT_RETURN(IsActive()==false, PJ_EBUSY);
+    PJ_ASSERT_RETURN(pending_data_.common_.op_key_==NULL, PJ_EBUSY);
+
+    pending_data_.accept_.op_key_ = op_key;
+    pending_data_.accept_.new_sock_ = new_sock;
+    pending_data_.accept_.local_ = local;
+    pending_data_.accept_.remote_ = remote;
+    pending_data_.accept_.addrlen_ = addrlen;
+
+    // Create blank socket
+    blank_sock_.Open(PjSymbianOS::Instance()->SocketServ());
+
+    type_ = TYPE_ACCEPT;
+    sock_->Socket().Accept(blank_sock_, iStatus);
+
+    if (iStatus==KRequestPending) {
+	SetActive();
+	return PJ_EPENDING;
+    } else {
+	return PJ_RETURN_OS_ERROR(iStatus.Int());
+    }
+}
+
+
+//
+// Completion callback.
+//
+void CIoqueueCallback::RunL()
+{
+    Type cur_type = type_;
+
+    type_ = TYPE_NONE;
+
+    if (cur_type == TYPE_READ) {
+	//
+	// Completion of asynchronous RecvFrom()
+	//
+
+	/* Clear op_key (save it to temp variable first!) */
+	pj_ioqueue_op_key_t	*op_key = pending_data_.read_.op_key_;
+	pending_data_.read_.op_key_ = NULL;
+
+	// Handle failure condition
+	if (iStatus != KErrNone) {
+	    cb_->on_read_complete(key_, op_key, 
+				  -PJ_RETURN_OS_ERROR(iStatus.Int()));
+	    return;
+	}
+
+	if (pending_data_.read_.addr_) {
+	    PjSymbianOS::Addr2pj(aAddress_, 
+				 *(pj_sockaddr_in*)pending_data_.read_.addr_);
+	    pending_data_.read_.addr_ = NULL;
+	}
+	if (pending_data_.read_.addrlen_) {
+	    *pending_data_.read_.addrlen_ = sizeof(pj_sockaddr_in);
+	    pending_data_.read_.addrlen_ = NULL;
+	}
+
+	/* Call callback */
+	cb_->on_read_complete(key_, op_key, aBufferPtr_.Length());
+
+    } else if (cur_type == TYPE_ACCEPT) {
+	//
+	// Completion of asynchronous Accept()
+	//
+	
+	/* Clear op_key (save it to temp variable first!) */
+	pj_ioqueue_op_key_t	*op_key = pending_data_.read_.op_key_;
+	pending_data_.read_.op_key_ = NULL;
+
+	// Handle failure condition
+	if (iStatus != KErrNone) {
+	    if (pending_data_.accept_.new_sock_)
+		*pending_data_.accept_.new_sock_ = PJ_INVALID_SOCKET;
+
+	    cb_->on_accept_complete(key_, op_key, PJ_INVALID_SOCKET,
+				    -PJ_RETURN_OS_ERROR(iStatus.Int()));
+	    return;
+	}
+
+	CPjSocket *pjNewSock = new CPjSocket(blank_sock_);
+
+	if (pending_data_.accept_.new_sock_) {
+	    *pending_data_.accept_.new_sock_ = (pj_sock_t)pjNewSock;
+	    pending_data_.accept_.new_sock_ = NULL;
+	}
+
+	if (pending_data_.accept_.local_) {
+	    TInetAddr aAddr;
+	    pj_sockaddr_in *ptr_sockaddr;
+
+	    blank_sock_.LocalName(aAddr);
+	    ptr_sockaddr = (pj_sockaddr_in*)pending_data_.accept_.local_;
+	    PjSymbianOS::Addr2pj(aAddr, *ptr_sockaddr);
+	    pending_data_.accept_.local_ = NULL;
+	}
+
+	if (pending_data_.accept_.remote_) {
+	    TInetAddr aAddr;
+	    pj_sockaddr_in *ptr_sockaddr;
+
+	    blank_sock_.RemoteName(aAddr);
+	    ptr_sockaddr = (pj_sockaddr_in*)pending_data_.accept_.remote_;
+	    PjSymbianOS::Addr2pj(aAddr, *ptr_sockaddr);
+	    pending_data_.accept_.remote_ = NULL;
+	}
+
+	if (pending_data_.accept_.addrlen_) {
+	    *pending_data_.accept_.addrlen_ = sizeof(pj_sockaddr_in);
+	    pending_data_.accept_.addrlen_ = NULL;
+	}
+
+	// Call callback.
+	cb_->on_accept_complete(key_, op_key, (pj_sock_t)pjNewSock, 
+				PJ_SUCCESS);
+    }
+
+    ioqueue_->eventCount++;
+}
+
+//
+// CActive's DoCancel()
+//
+void CIoqueueCallback::DoCancel()
+{
+    if (type_ == TYPE_READ)
+	sock_->Socket().CancelRecv();
+    else if (type_ == TYPE_ACCEPT)
+	sock_->Socket().CancelAccept();
+
+    type_ = TYPE_NONE;
+}
+
+//
+// Cancel operation and call callback.
+//
+void CIoqueueCallback::CancelOperation(pj_ioqueue_op_key_t *op_key, 
+				       pj_ssize_t bytes_status)
+{
+    Type cur_type = type_;
+
+    Cancel();
+
+    if (cur_type == TYPE_READ)
+	cb_->on_read_complete(key_, op_key, bytes_status);
+    else if (cur_type == TYPE_ACCEPT)
+	;
+}
+
+
+/////////////////////////////////////////////////////////////////////////////
 /*
  * IO Queue key structure.
@@ -376,6 +461,6 @@
     pj_ioqueue_key_t *key;
 
-    key = (pj_ioqueue_key_t*) pj_pool_alloc(pool, sizeof(pj_ioqueue_key_t));
-    key->cbObj = new CIoqueueCallback(ioq, key, sock, cb, user_data);
+    key = (pj_ioqueue_key_t*) pj_pool_zalloc(pool, sizeof(pj_ioqueue_key_t));
+    key->cbObj = CIoqueueCallback::NewL(ioq, key, sock, cb, user_data);
 
     *p_key = key;
@@ -390,4 +475,9 @@
     if (key == NULL || key->cbObj == NULL)
 	return PJ_SUCCESS;
+
+    // Cancel pending async object
+    if (key->cbObj && key->cbObj->IsActive()) {
+	key->cbObj->Cancel();
+    }
 
     // Close socket.
@@ -395,7 +485,9 @@
     delete key->cbObj->get_pj_socket();
 
-    // Delete async object
-    delete key->cbObj;
-    key->cbObj = NULL;
+    // Delete async object.
+    if (key->cbObj) {
+	delete key->cbObj;
+	key->cbObj = NULL;
+    }
 
     return PJ_SUCCESS;
@@ -519,5 +611,6 @@
 
     if (timeout) {
-	if (!ioq->timeoutTimer->IsActive())
+	//if (!ioq->timeoutTimer->IsActive())
+	if (0)
 	    timer = ioq->timeoutTimer;
 	else
@@ -534,10 +627,10 @@
     do {
 	PjSymbianOS::Instance()->WaitForActiveObjects();
-    } while (ioq->eventCount == 0 && !timer->HasTimedOut());
-
-    if (!timer->HasTimedOut())
+    } while (ioq->eventCount == 0 && (!timer || (timer && !timer->HasTimedOut())));
+
+    if (timer && !timer->HasTimedOut())
 	timer->Cancel();
 
-    if (timer != ioq->timeoutTimer)
+    if (timer && timer != ioq->timeoutTimer)
 	delete timer;
 
@@ -555,5 +648,7 @@
 				     pj_uint32_t flags )
 {
-    return pj_ioqueue_recvfrom(key, op_key, buffer, length, flags, NULL, NULL);
+    // Clear flag
+    flags &= ~PJ_IOQUEUE_ALWAYS_ASYNC;
+    return key->cbObj->StartRead(op_key, buffer, length, flags, NULL, NULL);
 }
 
@@ -575,4 +670,6 @@
 	return PJ_EBUSY;
 
+    // Clear flag
+    flags &= ~PJ_IOQUEUE_ALWAYS_ASYNC;
     return key->cbObj->StartRead(op_key, buffer, length, flags, addr, addrlen);
 }
@@ -597,4 +694,7 @@
     PJ_ASSERT_RETURN((flags & PJ_IOQUEUE_ALWAYS_ASYNC)==0, PJ_EINVAL);
 
+    // Clear flag
+    flags &= ~PJ_IOQUEUE_ALWAYS_ASYNC;
+
     key->cbObj->get_pj_socket()->Socket().Send(aBuffer, flags, reqStatus, aLen);
     User::WaitForRequest(reqStatus);
@@ -603,5 +703,7 @@
 	return PJ_RETURN_OS_ERROR(reqStatus.Int());
 
-    *length = aLen.Length();
+    //At least in UIQ Emulator, aLen.Length() reports incorrect length
+    //for UDP (some newlc.com users seem to have reported this too).
+    //*length = aLen.Length();
     return PJ_SUCCESS;
 }
@@ -632,9 +734,12 @@
     PJ_ASSERT_RETURN(addrlen == sizeof(pj_sockaddr_in), PJ_EINVAL);
 
+    // Clear flag
+    flags &= ~PJ_IOQUEUE_ALWAYS_ASYNC;
+
     aBuffer.Set((const TUint8*)data, (TInt)*length);
     PjSymbianOS::pj2Addr(*(const pj_sockaddr_in*)addr, inetAddr);
     CPjSocket *pjSock = key->cbObj->get_pj_socket();
 
-    pjSock->Socket().Send(aBuffer, flags, reqStatus, aLen);
+    pjSock->Socket().SendTo(aBuffer, inetAddr, flags, reqStatus, aLen);
     User::WaitForRequest(reqStatus);
 
@@ -642,6 +747,8 @@
 	return PJ_RETURN_OS_ERROR(reqStatus.Int());
 
-    *length = aLen.Length();
-    return PJ_SUCCESS;
-}
-
+    //At least in UIQ Emulator, aLen.Length() reports incorrect length
+    //for UDP (some newlc.com users seem to have reported this too).
+    //*length = aLen.Length();
+    return PJ_SUCCESS;
+}
+
Index: /pjproject/branches/symbian/pjlib/src/pj/lock.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/lock.c	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/lock.c	(revision 789)
@@ -64,5 +64,5 @@
     PJ_ASSERT_RETURN(pool && lock, PJ_EINVAL);
 
-    p_lock = pj_pool_alloc(pool, sizeof(pj_lock_t));
+    p_lock = (pj_lock_t*) pj_pool_alloc(pool, sizeof(pj_lock_t));
     if (!p_lock)
 	return PJ_ENOMEM;
@@ -150,5 +150,5 @@
     PJ_ASSERT_RETURN(pool && lock, PJ_EINVAL);
 
-    p_lock = pj_pool_alloc(pool, sizeof(pj_lock_t));
+    p_lock = (pj_lock_t*) pj_pool_alloc(pool, sizeof(pj_lock_t));
     if (!p_lock)
 	return PJ_ENOMEM;
Index: /pjproject/branches/symbian/pjlib/src/pj/os_core_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/os_core_symbian.cpp	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/os_core_symbian.cpp	(revision 789)
@@ -47,4 +47,12 @@
     void	   *tls_values[PJ_MAX_TLS];
 
+#if defined(PJ_OS_HAS_CHECK_STACK) && PJ_OS_HAS_CHECK_STACK!=0
+    pj_uint32_t	    stk_size;
+    pj_uint32_t	    stk_max_usage;
+    char	   *stk_start;
+    const char	   *caller_file;
+    int		    caller_line;
+#endif
+
 } main_thread;
 
@@ -54,4 +62,9 @@
 };
 
+struct pj_sem_t
+{
+    int value;
+    int max;
+};
 
 /* Flags to indicate which TLS variables have been used */
@@ -67,5 +80,5 @@
 
 CPjTimeoutTimer::CPjTimeoutTimer()
-: CActive(EPriorityNormal), hasTimedOut_(false)
+: CActive(EPriorityNormal), hasTimedOut_(PJ_FALSE)
 {
 }
@@ -80,4 +93,5 @@
 void CPjTimeoutTimer::ConstructL()
 {
+    hasTimedOut_ = PJ_FALSE;
     timer_.CreateLocal();
     CActiveScheduler::Add(this);
@@ -86,5 +100,5 @@
 CPjTimeoutTimer *CPjTimeoutTimer::NewL()
 {
-    CPjTimeoutTimer *self = new (ELeave) CPjTimeoutTimer;
+    CPjTimeoutTimer *self = new CPjTimeoutTimer;
     CleanupStack::PushL(self);
 
@@ -101,17 +115,19 @@
 	Cancel();
 
-    hasTimedOut_ = false;
+    hasTimedOut_ = PJ_FALSE;
     timer_.After(iStatus, miliSeconds * 1000);
     SetActive();
+
+    pj_assert(iStatus==KRequestPending);
 }
 
 bool CPjTimeoutTimer::HasTimedOut() const
 {
-    return hasTimedOut_;
+    return hasTimedOut_ != 0;
 }
 
 void CPjTimeoutTimer::RunL()
 {
-    hasTimedOut_ = true;
+    hasTimedOut_ = PJ_TRUE;
 }
 
@@ -252,4 +268,7 @@
 {
     pj_ansi_strcpy(main_thread.obj_name, "pjthread");
+
+    // Init main thread
+    pj_memset(&main_thread, 0, sizeof(main_thread));
 
     // Initialize PjSymbianOS instance
@@ -365,5 +384,11 @@
 PJ_DEF(pj_status_t) pj_thread_sleep(unsigned msec)
 {
+    //Not a good idea, as we don't want network events to
+    //arrive while we're not polling them:
+    //PjSymbianOS::Instance()->WaitForActiveObjects();
+
+    //.. so rather use this, which won't wake up Active Objects:
     User::After(msec*1000);
+
     return PJ_SUCCESS;
 }
@@ -642,55 +667,118 @@
 				   unsigned initial, 
                                    unsigned max,
-				   pj_sem_t **sem)
-{
-    PJ_UNUSED_ARG(pool);
+				   pj_sem_t **p_sem)
+{
+    pj_sem_t *sem;
+ 
     PJ_UNUSED_ARG(name);
-    PJ_UNUSED_ARG(initial);
-    PJ_UNUSED_ARG(max);
+
+    sem = (pj_sem_t*) pj_pool_zalloc(pool, sizeof(pj_sem_t));
+    sem->value = initial;
+    sem->max = max;
+
+    *p_sem = sem;
+
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Wait for semaphore.
+ */
+PJ_DEF(pj_status_t) pj_sem_wait(pj_sem_t *sem)
+{
+    if (sem->value > 0) {
+	sem->value--;
+	return PJ_SUCCESS;
+    } else {
+	pj_assert(!"Unexpected!");
+	return PJ_EINVALIDOP;
+    }
+}
+
+
+/*
+ * Try wait for semaphore.
+ */
+PJ_DEF(pj_status_t) pj_sem_trywait(pj_sem_t *sem)
+{
+    if (sem->value > 0) {
+	sem->value--;
+	return PJ_SUCCESS;
+    } else {
+	pj_assert(!"Unexpected!");
+	return PJ_EINVALIDOP;
+    }
+}
+
+
+/*
+ * Release semaphore.
+ */
+PJ_DEF(pj_status_t) pj_sem_post(pj_sem_t *sem)
+{
+    sem->value++;
+    return PJ_SUCCESS;
+}
+
+
+/*
+ * Destroy semaphore.
+ */
+PJ_DEF(pj_status_t) pj_sem_destroy(pj_sem_t *sem)
+{
     PJ_UNUSED_ARG(sem);
-
-    /* Unsupported */
-    return PJ_ENOTSUP;
-}
-
-
-/*
- * Wait for semaphore.
- */
-PJ_DEF(pj_status_t) pj_sem_wait(pj_sem_t *sem)
-{
-    PJ_UNUSED_ARG(sem);
-    return PJ_EINVALIDOP;
-}
-
-
-/*
- * Try wait for semaphore.
- */
-PJ_DEF(pj_status_t) pj_sem_trywait(pj_sem_t *sem)
-{
-    PJ_UNUSED_ARG(sem);
-    return PJ_EINVALIDOP;
-}
-
-
-/*
- * Release semaphore.
- */
-PJ_DEF(pj_status_t) pj_sem_post(pj_sem_t *sem)
-{
-    PJ_UNUSED_ARG(sem);
-    return PJ_EINVALIDOP;
-}
-
-
-/*
- * Destroy semaphore.
- */
-PJ_DEF(pj_status_t) pj_sem_destroy(pj_sem_t *sem)
-{
-    PJ_UNUSED_ARG(sem);
-    return PJ_EINVALIDOP;
-}
-
-
+    return PJ_SUCCESS;
+}
+
+
+#if defined(PJ_OS_HAS_CHECK_STACK) && PJ_OS_HAS_CHECK_STACK != 0
+/*
+ * The implementation of stack checking. 
+ */
+PJ_DEF(void) pj_thread_check_stack(const char *file, int line)
+{
+    char stk_ptr;
+    pj_uint32_t usage;
+    pj_thread_t *thread = pj_thread_this();
+
+    pj_assert(thread);
+
+    /* Calculate current usage. */
+    usage = (&stk_ptr > thread->stk_start) ? &stk_ptr - thread->stk_start :
+		thread->stk_start - &stk_ptr;
+
+    /* Assert if stack usage is dangerously high. */
+    pj_assert("STACK OVERFLOW!! " && (usage <= thread->stk_size - 128));
+
+    /* Keep statistic. */
+    if (usage > thread->stk_max_usage) {
+	thread->stk_max_usage = usage;
+	thread->caller_file = file;
+	thread->caller_line = line;
+    }
+}
+
+/*
+ * Get maximum stack usage statistic. 
+ */
+PJ_DEF(pj_uint32_t) pj_thread_get_stack_max_usage(pj_thread_t *thread)
+{
+    return thread->stk_max_usage;
+}
+
+/*
+ * Dump thread stack status. 
+ */
+PJ_DEF(pj_status_t) pj_thread_get_stack_info(pj_thread_t *thread,
+					     const char **file,
+					     int *line)
+{
+    pj_assert(thread);
+
+    *file = thread->caller_file;
+    *line = thread->caller_line;
+    return 0;
+}
+
+#endif	/* PJ_OS_HAS_CHECK_STACK */
Index: /pjproject/branches/symbian/pjlib/src/pj/os_error_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pj/os_error_symbian.cpp	(revision 788)
+++ /pjproject/branches/symbian/pjlib/src/pj/os_error_symbian.cpp	(revision 789)
@@ -117,6 +117,9 @@
 }
 
-extern "C" int platform_strerror( pj_os_err_type os_errcode, 
-                       		  char *buf, pj_size_t bufsize);
+extern "C" 
+{
+    PJ_DECL(int) platform_strerror( pj_os_err_type os_errcode, 
+                       		    char *buf, pj_size_t bufsize);
+}
 
 /* 
@@ -126,6 +129,6 @@
  * in errno.c 
  */
-int platform_strerror( pj_os_err_type os_errcode, 
-                       char *buf, pj_size_t bufsize)
+PJ_DEF(int) platform_strerror( pj_os_err_type os_errcode, 
+			       char *buf, pj_size_t bufsize)
 {
     int len = 0;
